package ld20.gameobject
{
    import flash.display.Bitmap;
    import ld20.Embedded;
    import stego.GameInterface;
	import stego.GameObject;
    import stego.gameobject.TileMap;
    import stego.util.collision.CollisionInfo;
	
	/**
     * ...
     * @author Michael Meyer
     */
    public class Bullet extends GameObject
    {
        override public function init(game:GameInterface):void
        {
            super.init(game);
            if (0 == numChildren)
            {
                var bmp:Bitmap = new Bitmap(Embedded.sprites_bullet);
                bmp.x = -0.5 * bmp.width;
                bmp.y = -0.5 * bmp.height;
                addChild(bmp);
            }
        }

        override public function collisionOccurred(ci:CollisionInfo, object:GameObject):void
        {
            if (!canPassThrough(ci, object))
            {
                if (object is TileMap)
                {
                    alive = false;
                }
                else if (object is Player)
                {
                    if (ci.hitbox2.userData["item"] == Embedded.shieldImage)
                    {
                        alive = false;
                    }
                    else if (ci.hitbox2.userData["item"] == "body")
                    {
                        object.alive = false;
                    }
                }
                else if (object is Enemy)
                {
                    this.alive = false;
                }
            }
        }

        override public function canPassThrough(ci:CollisionInfo, object:GameObject):Boolean
        {
            var userdata:Object = ci.hitbox2.userData;
            return (userdata && userdata.hasOwnProperty("nocollide"));
        }
    }
}