package ld20.gameobject
{
    import flash.display.Bitmap;
    import ld20.Embedded;
    import stego.GameInterface;
	import stego.GameObject;
    import stego.util.collision.CollisionInfo;
    import stego.util.GraphicsUtil;
	
	/**
     * ...
     * @author Michael Meyer
     */
    public class SwordSource extends GameObject
    {
        override public function init(game:GameInterface):void
        {
            super.init(game);
            if (0 == numChildren)
            {
                var bmp:Bitmap = new Bitmap(Embedded.swordImage);
                bmp.x = -0.5 * bmp.width;
                bmp.y = -0.5 * bmp.height;
                addChild(bmp);
            }
        }

        override public function collisionOccurred(ci:CollisionInfo, object:GameObject):void
        {
            if (object is Player)
            {
                var p:Player = object as Player;
                if (p.attached != Embedded.swordImage)
                {
                    p.attach(Embedded.swordImage);
                }
            }
        }
        override public function canPassThrough(ci:CollisionInfo, object:GameObject):Boolean
        {
            var userdata:Object = ci.hitbox2.userData;
            return (userdata && userdata.hasOwnProperty("nocollide"));
        }
    }

}