package ld20.gamestate
{
    import flash.display.Bitmap;
    import flash.display.Sprite;
    import ld20.Embedded;
    import ld20.ui.TitleScreenButton;
    import stego.constants.Colors;
    import stego.GameInterface;
	import stego.GameState;
    import stego.ui.Fader;
    import stego.util.GuiBuilder;
    import stego.util.scene.GameObjectHolder;
	
    public class Title extends GameState
    {
        protected var uiLayer:GameObjectHolder;
        protected var button:TitleScreenButton;

        override public function begin(game:GameInterface):void
        {
            super.begin(game);

            uiLayer = game.layers.addLayer();

            var guiBuilder:GuiBuilder = new GuiBuilder(game.stageRect, uiLayer);
            guiBuilder.font = Embedded.TuffyBoldFont;
            guiBuilder.fontSize = 60;
            guiBuilder.fontColor = Colors.WHITE_ENOUGH;
            guiBuilder.highlightColor = Colors.WHITE;
            guiBuilder.addTextCentered("Danger. Take.", 0.5, 0.4);
            guiBuilder.fontSize = 30;

            button = uiLayer.add(TitleScreenButton) as TitleScreenButton;
            button.x = 0.5 * game.stageWidth;
            button.y = 0.65 * game.stageHeight;
            button.callback = startGame;

            var fader:Fader = uiLayer.add(Fader) as Fader;
            fader.fadeToColor(0, 0xFFFFFF);
            fader.fadeBack(1);
            fader.mouseEnabled = false;
        }

        protected function startGame():void
        {
            button.callback = null;
            game.changeGameState(new Playing());
        }

        override public function end():void
        {
            super.end();
            game.layers.remove(uiLayer);
            uiLayer = null;
        }
    }
}