import os
import re
import fileinput
import sys

def remove_matching_lines_from_file(file, regex):
    for line in fileinput.input(file, inplace=True):
        if not re.match(regex, line):
            sys.stdout.write(line)

# regex for finding imported classes 
# (puts the class name in group 2 and the preceding stuff in group 1)
import_re = re.compile(r'(import [\w.]*[.])([\w]*);')

allowed_extensions = ['.as']

for root, dirs, files, in os.walk('src', topdown=False):
    for file in files:
        name, extension = os.path.splitext(file)
        if extension.lower() in allowed_extensions:
            fullpath = os.path.join(root, file)
            contents = open(fullpath).read()
            for import_prefix, classname in import_re.findall(contents):
                regex = r'(?<!%s)%s' % (import_prefix, classname)
                if None == re.search(regex, contents):
                    remove_matching_lines_from_file( fullpath, 
                                                     r'\s*%s%s' % (import_prefix,classname) )

                    