import os

template = """// quick hack for syntax checking everything.  Run generate_syntax_check_code.py to regenerate.' )

package stego
{
%s
    public class IncludeEverything
    {
        private static function _include_everything():void
        {
            var _classes:Array = [\n                %s ];
        }
    }
}
"""

def get_classnames(root='.', package=''):
    paths = os.listdir(root)
    for path in paths:
        subpath = os.path.join(root, path)
        if os.path.isdir(subpath):
            subpackage = path.lower() if package=='' else package+'.'+path.lower()
            for classname in get_classnames(subpath, subpackage):
                yield classname
        elif os.path.isfile(subpath):
            name, extension = os.path.splitext(path)
            if extension.lower()=='.as':
                yield '%s.%s' % (package, name)

os.chdir('src')

import_code = '\n'.join( ('    import %s;'%classname for classname in get_classnames() ) )
class_list = ',\n                '.join( get_classnames() )

f = open('stego/IncludeEverything.as', 'w')
f.write( template % (import_code, class_list) )
f.close()
