﻿package stego
{
    import flash.events.Event;
    import flash.events.EventDispatcher;
    import stego.GameInterface;
    import stego.script.Step;
    import stego.util.schedule.Schedule;

    /**
     * ...
     * @author Mike Meyer
     */
    public class GameState extends EventDispatcher implements stego.GameStateInterface
    {
        private var _game:GameInterface;
        public function get game():GameInterface { return _game; }

        protected var script:Step;
        public var scheduler:Schedule;

        /**
         * "heartbeat" function. called every frame
         */
        public function update():void
        {
            if (null != script)
            {
                script.execute(game.time.deltaTime);
            }
            if (null != scheduler)
            {
                scheduler.update(game.time.deltaTime);
            }
        }

        /**
         * called every frame before collisions
         */
        public function preCollision():void
        {
        }

        /**
         * called every frame to check collisions
         */
        public function collision():void
        {
        }

        /**
         * called every frame to integrate object motion
         */
        public function integrate():void
        {
        }

        /**
         * last-minute updating before things get rendered each frame
         */
        public function preDraw():void
        {
        }

        /**
         * Go back to the beginning
         */
        public function restart():void
        {
            end();
            begin(game);
            if (null != script)
            {
                script.restart();
            }
        }

        /**
         * get the gamestate ready to be played
         */
        public function begin(game:GameInterface):void
        {
            _game = game;

            if (null != script)
            {
                script.restart();
            }
            scheduler = new Schedule()
        }

        /**
         * clean up
         */
        public function end():void
        {
            if (null != script)
            {
                script.restart();
                script = null;
            }
            if (null != scheduler)
            {
                scheduler.shutdown();
                scheduler = null;
            }
        }
    }
}
