﻿package stego.behavior
{
    import stego.GameObject;
    import stego.util.InputUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Base implements IBehavior
    {
        public function get character() : GameObject { return _character; }
        protected var _character:GameObject;

        protected var _inputUtil:InputUtil;
        public function get inputUtil():InputUtil { return _inputUtil; }
        public function set inputUtil(value:InputUtil):void
        {
            _inputUtil = value;
        }

        public function Base(inputUtil:InputUtil)
        {
            _inputUtil = inputUtil;
        }

        /**
         * process one frame
         * Override this!
         */
        public function update(deltaTime:Number):void
        {
        }

        /**
         * get the behavior set up
         */
        public function init(character:GameObject):void
        {
            _character = character;
        }

        /**
         * clean up after init
         */
        public function shutdown():void
        {
            _character = null;
        }
    }

}
