﻿package stego.behavior
{
    import stego.GameObject;
    /**
     * interface that the different behaviors need to implement
     * @author Mike Meyer
     */
    public interface IBehavior
    {
        function get character() : GameObject

        /**
         * process one frame
         */
        function update(deltaTime:Number):void

        /**
         * get the behavior set up
         */
        function init(character:GameObject):void

        /**
         * clean up after init
         */
        function shutdown():void
    }

}
