﻿package stego.debug
{
    /**
     * Profiling utility
     * @author Mike Meyer
     */
    public class Profiler
    {
        public static var sections:Object = { };

        public static function startSection(name:String):void
        {
            var section:ProfilerSection;
            if (sections.hasOwnProperty(name))
            {
                section = sections[name];
            }
            else
            {
                section = new ProfilerSection();
                sections[name] = section;
            }
            section.start();
        }
        public static function endSection(name:String):void
        {
            if (sections.hasOwnProperty(name))
            {
                var section:ProfilerSection = sections[name];
                section.end();
            }
        }

        public static function traceProfilingInfo():void
        {
            trace("Profiling Info:  ");
            for (var key:String in Profiler.sections)
            {
                var ps:ProfilerSection = Profiler.sections[key];
                trace("----", key, "----");
                trace("  times:", ps.times);
                trace("  avg:",   ps.avg);
                trace("  min:",   ps.min);
                trace("  max:",   ps.max);
                trace("  total:", ps.total);
            }
        }

        public static function clearProfilingInfo():void
        {
            Profiler.sections = { };
        }
    }

}
