﻿package stego.script.step
{
    import flash.display.DisplayObject;
    import stego.script.Step;
    import stego.script.step.animate.AnimationValues;
    import stego.util.Easing;

    /**
     *
     * @author Mike Meyer
     */
    public class Animate extends Step
    {
        protected var target:DisplayObject;
        protected var duration:Number;
        protected var curTime:Number;
        protected var easing:Function;

        protected var startValues:AnimationValues;
        protected var endValues:AnimationValues;

        public function Animate(objectToAnimate:DisplayObject, startValues:Object, endValues:Object, animDuration:Number=1.0, easing:Function=null)
        {
            target = objectToAnimate;
            this.startValues = AnimationValues.buildFromObject(startValues);
            this.endValues = AnimationValues.buildFromObject(endValues);
            duration = animDuration;
            curTime = 0;
            this.easing = (easing == null) ? Easing.quadInOut : easing;
        }

        public override function execute(deltaTime:Number):Boolean
        {
            curTime += deltaTime;
            AnimationValues.animateBetween(target, startValues, endValues, curTime, duration, easing);
            return (curTime >= duration);
        }

        /**
         * Go back to the beginning
         */
        public override function restart():void
        {
            curTime = 0;
        }
    }

}
