﻿package stego.util
{
    /**
     * utility functions for working with Arrays
     * @author Mike Meyer
     */
    public class ArrayUtil
    {
        /**
         * remove items that are equal to the provided value
         */
        public static function removeEqual(a:Array, search:*, howMany:int=-1):void
        {
            removePredicate(a, function(x:*):Boolean { return (x == search); }, howMany );
        }

        /**
         * remove items for which the given predicate evaluates to true
         */
        public static function removePredicate(a:Array, predicate:Function, howMany:int=-1):void
        {
            for (var i:Number = 0 ; i < a.length; ++i)
            {
                if (predicate(a[i]))
                {
                    a.splice(i, 1);
                    if (howMany != -1)
                    {
                        --howMany;
                        if (howMany <= 0)
                        {
                            return;
                        }
                    }
                }
            }
        }

        /**
         * return a random one of the things in an array
         */
        public static function randomOneOf(a:Array):*
        {
            return a[int(Math.random() * a.length)];
        }

        /**
         * rearrange the given array into a random order
         */
        public static function shuffle(a:Array):void
        {
            var len:int = a.length,
                fromIndex:int = 0,
                toIndex:int,
                temp:*;
            for (; fromIndex < len-1; ++fromIndex)
            {
                temp = a[toIndex];
                a[toIndex] = a[fromIndex = MathUtil.randomRange(toIndex, len)];
                a[fromIndex] = temp;
            }
        }
    }
}
