package stego.util
{
    /**
     * static methods that are handy for working with strings
     */
    public class StringUtil
    {
        /**
         * returns true IFF string b appears at the very beginning of string a
         */
        public static function startsWith(a:String, b:String):Boolean
        {
            return (0 == a.indexOf(b));
        }

        /**
         * returns true IFF string b appears at the very end of string a
         */
        public static function endsWith(a:String, b:String):Boolean
        {
            return (a.length>=b.length)&&((a.length-b.length) == a.lastIndexOf(b));
        }

        /**
         * pad the string with leading whitespace if necessary to make it at least n characters long
         */
        public static function fixedWidth(s:String, n:uint):String
        {
            while (s.length < n)
            {
                s = " " + s;
            }
            return s;
        }
    }
}
