package stego.util.collision
{
    import flash.geom.Rectangle;

    /**
     * class for representing collision volumes w/ userdata
     * @author Michael Meyer
     */
    public class HitBox extends Rectangle
    {
        public var userData:Object;
        public var color:uint;

        public function HitBox( x:Number = 0,
                                y:Number = 0,
                                width:Number = 0,
                                height:Number = 0,
                                userData:Object = null,
                                color:uint = 0xFFFFFF)
        {
            this.x = x;
            this.y = y;
            this.width = width;
            this.height = height;
            this.userData = userData;
            this.color = color;
        }

        /** make this Hitbox into a clone of another */
        public function makeIntoCopyOf(other:HitBox):void
        {
            userData = other.userData;
            color = other.color;
            x = other.x;
            y = other.y;
            width = other.width;
            height = other.height;
        }

        /** make a copy */
        override public function clone():Rectangle
        {
            return new HitBox(x,y,width,height,userData,color);
        }
    }

}
