package stego.util.music
{
    import flash.errors.IOError;
    import flash.events.Event;
    import flash.events.IOErrorEvent;
    import flash.media.Sound;
    import flash.media.SoundLoaderContext;
    import flash.net.URLRequest;

	/**
     * ...
     * @author Mike Meyer
     */
    public class StreamedSong extends Song
    {
        private var _url:String;
        public function get url():String { return _url; }

        public function StreamedSong(url:String, title:String, artist:String, link:String=null, volume:Number = 0.5)
        {
            _url = url;
            super(title, artist, link, volume);
        }

        override public function start():void
        {
            sound = new Sound();
            var request:URLRequest = new URLRequest(url);
            var context:SoundLoaderContext = new SoundLoaderContext(8000, false);

            sound.addEventListener(IOErrorEvent.IO_ERROR, soundFail);
            sound.addEventListener(Event.OPEN, soundLoadBegin);
            sound.load(request, context);
        }

        /**
         * music has been successfully found and can start playing
         */
        private function soundLoadBegin(e:Event):void
        {
            if (beginPlaying())
            {
                if (null != onSongBeginCb)
                {
                    onSongBeginCb();
                }
            }
        }

        /**
         * something went horribly wrong
         */
        private function soundFail(e:IOErrorEvent):void
        {
            if (null != sound)
            {
                try
                {
                    sound.close();
                }
                catch (e:IOError)
                {
                }

                sound.removeEventListener(IOErrorEvent.IO_ERROR, soundFail);
                sound.removeEventListener(Event.OPEN, soundLoadBegin);
                sound = null;
            }

            if (null != onFailCb)
            {
                onFailCb();
            }
        }
    }
}
